//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Runtime.InteropServices;

namespace Bon.Remoting
{
	/// <summary>
	/// vO̗\C^[tFCXłB
	/// </summary>
	[ComVisible(true)]
	[Guid("0FB5862D-D9D9-44a0-BC1A-28EE2821B43B")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public interface IRegisteredProgram
	{
		/// <summary>
		/// \ӂɎʂIDłB
		/// </summary>
		[Category("General")]
		Guid RegisteredID
		{
			get;
		}

		/// <summary>
		/// \񂳂ꂽ擾܂B
		/// </summary>
		[Category("General")]
		DateTime RegisteredTime
		{
			get;
		}

		/// <summary>
		/// Xg[i[Xg[WID擾܂B
		/// </summary>
		[Category("General")]
		string StorageID
		{
			get;
		}

		/// <summary>
		/// Xg[i[t@C擾܂B
		/// </summary>
		/// <remarks>̐ݒ́Aۂɕۑt@C̈ꕔƂĎg܂B</remarks>
		[Category("General")]
		string FileName
		{
			get;
		}

		/// <summary>
		/// `[i[̃Xg[URLłB
		/// </summary>
		[Category("Target Stream")]
		IUrl TunerStreamUrl
		{
			get;
		}

		/// <summary>
		/// `[jOXy[X擾܂B
		/// </summary>
		[Category("Target Stream")]
		int TuningSpace
		{
			get;
		}

		/// <summary>
		/// `l擾܂B
		/// </summary>
		[Category("Target Stream")]
		int Channel
		{
			get;
		}

		/// <summary>
		/// vOID擾܂B
		/// </summary>
		[Category("Target Stream")]
		int ProgramID
		{
			get;
		}

		/// <summary>
		/// Xg[̘^Jn擾܂B
		/// </summary>
		[Category("Recording Time")]
		DateTime StartTime
		{
			get;
		}

		/// <summary>
		/// Xg[^悷Ԋu擾܂B
		/// </summary>
		[Category("Recording Time")]
		TimeSpan Duration
		{
			get;
		}
	}
}
