//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.ComponentModel;
using System.Collections;
using System.Runtime.InteropServices;

namespace Bon.Remoting
{
	/// <summary>
	/// R[_[𒊏ۉC^[tFCXłB
	/// </summary>
	/// <remarks>R[_[̐ɕKvȃ\bh`Ă܂B</remarks>
	[ComVisible(true)]
	[Guid("52CE9B15-15AF-4670-82A7-AA47D0C324B2")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public interface IRemoteRecorder : IEnumerable
	{
		/// <summary>
		/// R[_[̗LԂ擾܂B
		/// </summary>
		bool Enabled
		{
			get;
		}

		/// <summary>
		/// \Q̐擾܂B
		/// </summary>
		int Count
		{
			get;
		}

		/// <summary>
		/// w肳ꂽ\ID̗\擾܂B
		/// </summary>
		/// <param name="registeredID">\ID</param>
		/// <returns>\</returns>
		IRegisteredProgram this[Guid registeredID]
		{
			get;
		}

		/// <summary>
		/// t@C̕ۑΏۂƂȂXg[W̍Œ󂫗eʂ擾܂B
		/// </summary>
		long MinimumSpaceRequirements
		{
			get;
		}

		/// <summary>
		/// t@C̕ۑΏۂƂȂXg[WIDQ擾܂B
		/// </summary>
		string[] StorageIDs
		{
			get;
		}

		/// <summary>
		/// Xg[W݂̌̋󂫗eʂ擾܂B
		/// </summary>
		/// <param name="storageID">Xg[i[Xg[WID</param>
		/// <returns>󂫗e</returns>
		long GetCurrentSpaces(string storageID);

		/// <summary>
		/// vO\s܂B
		/// </summary>
		/// <param name="tunerStreamUrl">`[i[Xg[URL</param>
		/// <param name="tuningSpace">`[i[Xy[X</param>
		/// <param name="channel">`l</param>
		/// <param name="programID">vOID</param>
		/// <param name="startTime">Jn</param>
		/// <param name="duration">Ԋu</param>
		/// <param name="storageID">Xg[i[Xg[WID</param>
		/// <param name="fileName">t@C</param>
		/// <returns>\ID</returns>
		/// <remarks>t@Cɂ͗\ɊÂvtBbNXǉ܂B</remarks>
		Guid RegisterProgram(IUrl tunerStreamUrl, int tuningSpace, int channel, int programID,
			DateTime startTime, TimeSpan duration, string storageID, string fileName);

		/// <summary>
		/// ^Jn܂B
		/// </summary>
		/// <param name="tunerStreamUrl">`[i[Xg[URL</param>
		/// <param name="tuningSpace">`[i[Xy[X</param>
		/// <param name="channel">`l</param>
		/// <param name="programID">vOID</param>
		/// <param name="storageID">Xg[i[Xg[WID</param>
		/// <param name="fileName">t@C</param>
		/// <returns>\ID</returns>
		/// <remarks>t@Cɂ͗\ɊÂvtBbNXǉ܂B</remarks>
		Guid StartRecord(IUrl tunerStreamUrl, int tuningSpace, int channel, int programID,
			string storageID, string fileName);

		/// <summary>
		/// \^̏Ԃ擾܂B
		/// </summary>
		/// <param name="registeredID">\ID</param>
		/// <returns>\</returns>
		RecordingStates GetRecordingStatus(Guid registeredID);

		/// <summary>
		/// ^IɊJn܂B
		/// </summary>
		/// <param name="registeredID">\ID</param>
		void StartRecord(Guid registeredID);

		/// <summary>
		/// ^JnƊԊuĐݒ肵܂B
		/// </summary>
		/// <param name="registeredID">\ID</param>
		/// <param name="startTime">^Jn</param>
		/// <param name="duration">^Ԋu</param>
		/// <remarks>̃\bhgpƁA^JnƊԊuύX鎖o܂B
		/// ̍ہA蓮ŊJn^̏ꍇ͗\^ƓɕύX܂B</remarks>
		void ResetTime(Guid registeredID, DateTime startTime, TimeSpan duration);

		/// <summary>
		/// ^Iɒ~܂B
		/// </summary>
		/// <param name="registeredID">\ID</param>
		void StopRecord(Guid registeredID);

		/// <summary>
		/// ̗\폜܂B
		/// </summary>
		/// <param name="registeredID">\ID</param>
		void Remove(Guid registeredID);

		/// <summary>
		/// \Q񋓂܂B
		/// </summary>
		/// <returns>񋓎q</returns>
		new IEnumerator GetEnumerator();
	}
}
