//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#pragma once

namespace Bon
{
	ref class SelectedChannel sealed
		: public ISelectedChannel
	{
	private:
		initonly int tuningSpace_;
		initonly int channel_;

	internal:
		SelectedChannel(int tuningSpace, int channel);

	public:
		property int TuningSpace
		{
			virtual int get();
		}

		property int Channel
		{
			virtual int get();
		}
	};
}
