//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#pragma once

namespace Bon
{
	ref class TuningSpaceInformation sealed
		: public ITuningSpaceInformation
	{
	private:
		initonly System::String^ name_;
		initonly array<System::String^>^ channels_;

	internal:
		TuningSpaceInformation(System::String^ name, array<System::String^>^ channels);

	public:
		virtual int GetHashCode() override;

		property System::String^ Name
		{
			virtual System::String^ get();
		}

		virtual System::Collections::IEnumerator^ GetEnumerator();
	};
}
