//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Runtime.InteropServices;

namespace Bon.Remoting
{
	/// <summary>
	/// `[jOXy[Xƃ`l𒊏ۉNXłB
	/// </summary>
	/// <remarks>̃NX̓VA\œǂݎpłB</remarks>
	[Serializable]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public sealed class RemoteTuningSpaceInformation : IRemoteTuningSpaceInformation
	{
		private readonly string name_;
		private readonly string[] channels_;

		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="tuningSpaceInformation">ƂȂ`[jOXy[X</param>
		/// <remarks>Ŏw肳ꂽ`[jOXy[XRs[Ċi[܂B</remarks>
		public RemoteTuningSpaceInformation(ITuningSpaceInformation tuningSpaceInformation)
		{
			name_ = tuningSpaceInformation.Name;

			List<string> temp = new List<string>();
			foreach (string channel in tuningSpaceInformation)
			{
				temp.Add(channel);
			}

			channels_ = temp.ToArray();
		}

		/// <summary>
		/// `[jOXy[X擾܂B
		/// </summary>
		[Category("Tuning Space")]
		public string Name
		{
			get
			{
				return name_;
			}
		}

		/// <summary>
		/// `lQ擾܂B
		/// </summary>
		[Category("Channel")]
		public string[] Channels
		{
			get
			{
				return channels_;
			}
		}
	}
}
