//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#pragma once

#include "TsData.h"

namespace Bon
{
	ref class RawTsData sealed
		: public IRawTsData
	{
	private:
		ITsData^ data_;
		System::Runtime::InteropServices::GCHandle handle_;

	internal:
		RawTsData(ITsData^ data);

	public:
		~RawTsData();

		property int Size
		{
			virtual int get();
		}

		property array<System::Byte>^ Data
		{
			virtual array<System::Byte>^ get();
		}

		property System::IntPtr RawData
		{
			virtual System::IntPtr get();
		}
	};
}
