//////////////////////////////////////////////////////////////////////////
// BonSDK Stream service remote controller
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Net;
using Bon.Remoting;

namespace Bon
{
	/// <summary>
	/// w肳ꂽ[g`[i[ɑ΂ăvOIDݒ肷NXłB
	/// </summary>
	internal sealed class ProgramSetter
	{
		private readonly IRemoteTuner tuner_;
		private readonly IPEndPoint endPoint_;
		private readonly int programID_;

		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="tuner">[g`[i[Q</param>
		/// <param name="endPoint">vOIDݒ肷Ώۂ̃Xg[NCAg</param>
		/// <param name="programID">ݒ肷vOID</param>
		public ProgramSetter(IRemoteTuner tuner, IPEndPoint endPoint, int programID)
		{
			tuner_ = tuner;
			endPoint_ = endPoint;
			programID_ = programID;
		}

		/// <summary>
		/// vOID̐ݒs܂B
		/// </summary>
		public void SetProgram()
		{
			tuner_.SetProgramID(endPoint_, programID_);
		}
	}
}
