//////////////////////////////////////////////////////////////////////////
// BonSDK library header file
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// BonObject.h: x[XC^tF[XNX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


namespace Bon
{

/////////////////////////////////////////////////////////////////////////////
// BonIuWFNgC^tF[XNX
/////////////////////////////////////////////////////////////////////////////

class BONAPI CBonObject	: public IBonObject
{
public:
// IBonObject
	virtual void Release(void);
	virtual const BONGUID GetGuid(void) const;

// CBonObject
	CBonObject(IBonObject *pOwner = NULL);
	virtual ~CBonObject(void);

	static IBonObject * CreateInstance(IBonObject *pOwner);

protected:
	static const BONGUID TypeToGuid(const type_info &TypeID);

	IBonObject *m_pOwner;

private:
	CBonObject(const CBonObject &);
	void operator =(const CBonObject &);
};


/////////////////////////////////////////////////////////////////////////////
// IBonObjectCvg}N
/////////////////////////////////////////////////////////////////////////////

#define DECLARE_IBONOBJECT(C)	\
	static IBonObject * CreateInstance(IBonObject *pOwner){return reinterpret_cast<IBonObject *>(new C(pOwner));}\
	virtual void Release(void){CBonObject::Release();}\
	virtual const BONGUID GetGuid(void) const {return CBonObject::TypeToGuid(typeid(C));}

}
